import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private aah;
    get aai(): IAnchoredCategorySeriesInteractionManager;
    aad: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    mb(): string;
    protected cq(): SeriesView;
    qw(a: SeriesView): void;
    aam: boolean;
    constructor();
    aa3: string;
    ko(a: any, b: string): any;
    ma(a: string): string;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private aaj;
    aav: string;
    aaz: string;
    aa1: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get abq(): Brush;
    set abq(a: Brush);
    static readonly abc: DependencyProperty;
    trendLineThickness: number;
    abs: PenLineCap;
    abr: DoubleCollection;
    trendLinePeriod: number;
    aaq: number;
    gb(a: any): boolean;
    protected aaa(a: number, b: number, c: Axis): any[];
    protected q4(a: any, b: string, c: any, d: any): void;
    ax(a: Axis): AxisRange;
    protected o8(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected zk(): number;
    aap(a: CategorySeriesView): number;
    aa9(a: PointCollection, b: number, c: CategorySeriesView): void;
    aab(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    aac(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    protected f9(): boolean;
    protected hr(): List$1<SeriesLayerPropertyOverlay>;
    private aa5;
    hc(a: Rect, b: Rect, c: SeriesView): boolean;
    o2(a: boolean, b: SeriesView): void;
    z0(a: CategoryFrame, b: CategorySeriesView): void;
    z3(a: CategoryFrame, b: CategorySeriesView): void;
    aae: CategoryFrame;
    rl(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    aa6(a: CategoryFrame, b: CategorySeriesView): void;
    protected sa(): void;
    ku(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected aat: string;
    protected aas: string;
    abstract aa7(a: Axis): void;
    abstract aa8(a: Axis): void;
    protected pu(a: any): void;
    aaf: CategorySeriesMarkerCollisionAvoidance;
    kl(a: Point): any;
    aag: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    iw(): number;
    protected get_aar(): number;
    protected get aar(): number;
    ay(a: Rect): AxisRange;
    private abb;
    private aal;
    private aan;
    aao: number;
    private aba;
    i6(a: ValueLayerValueMode, b: Axis): number;
    ap(a: ValueLayerValueMode): number[];
    v8(a: ValueLayerValueMode): Point;
    v9(a: number[]): Point;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c5: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c6;
    get c7(): ITrendLineManager;
    set c7(a: ITrendLineManager);
    get c8(): boolean;
    dc(): void;
    da(): void;
    c9(): void;
    cx(): CategoryBucketCalculator;
    db(): void;
    dd(): void;
    de(a: number): Rect;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
